/* menu.h - header for menu pgm */
#ifndef MENU_H
#define MENU_H
#include "local.h"
#include "screen.h"
typedef struct string_val
	{
	char edit_type;		/* 'n' = numeric, 'd' = short int, 'a' = anything */
	char *string;		/* ptr to the string value */
	short maxsize;		/* maximum size of string: {2:SHORT_MAX} */
	short *pnum;		/* if non-NULL, ptr to numeric storage */
	} STRING_VAL;
typedef struct choice_val
	{
	short nchoices;		/* number of possible choices: {2:10} */
	char **choices;		/* ptr to start of array of choice strings */
	char *pc;			/* ptr to the one-char coded choice value */
	} CHOICE_VAL;
/* (more)
.PE
.PS 33
 */
typedef struct field
	{
	short line, col;	/* co-ordinates of screen display position */
	char *desc;			/* description (title) of this field: string */
	char val_type;		/* what type of field is this?  */
	STRING_VAL *psv;	/* non-NULL iff val_type == 's' or 'S' */
	CHOICE_VAL *pcv;	/* non-NULL iff val_type == 'c' */
	struct menu *pmenu;	/* non-NULL iff val_type == 'm' */
	bool (*pfn)();		/* function to do after str or choice field */
	} FIELD;
typedef struct menu
	{
	char *title;		/* alphabetic title for menu: string */
	FIELD *fields;		/* ptr to beginning of array of FIELDs */
	short nfields;		/* how many fields in this menu */
	short cur_field;	/* index of the current field */
	} MENU;
FIELD *mu_ask();		/* PARMS(MENU *pm) */
SCR_CMDCHAR mu_chv();	/* PARMS(FIELD *pf) */
void mu_do();			/* PARMS(MENU *pm) */
void mu_pr();			/* PARMS(MENU *pm) */
int mu_reply();			/* PARMS(char *prompt, char *reply, int size) */
SCR_CMDCHAR mu_str();	/* PARMS(FIELD *pf) */
SCR_CMDCHAR mu_sval();	/* PARMS(STRING_VAL *psv) */
#endif
